#ifndef PERIODIC_PI_H
#define PERIODIC_PI_H

#include "mbed.h"

class PeriodicPI
{
public:
    PeriodicPI(float periodSec, float kP=0, float kI=0);
    float Run(float error, float bound);
    float GetIntegral();
    float GetOutput();
    void Reset();
    
    float kP;
    float kI;

private:
    float integral;
    float output;
    float periodSec;

};

#endif // PERIODIC_PI_H